class M4eRole {
  final String _role;

  const M4eRole._(this._role);

  // TODO: revisit and validate
  static const OWNER = M4eRole._('OWNER');
  static const MANAGER = M4eRole._('MANAGER');
  static const VIEWER = M4eRole._('VIEWER');
  static const REPORTER = M4eRole._('REPORTER');

  M4eRole parse(String role) {
    return M4eRole._(role);
  }

  @override
  bool operator ==(Object o) {
    if (identical(this, o)) return true;

    return o is M4eRole && o._role == _role;
  }

  @override
  int get hashCode => _role.hashCode;

  @override
  String toString() => _role;
}
